package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AboutUs;
import com.izouma.awesomeadmin.service.AboutUsService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aboutUs")
@RequiresAuthentication
public class AboutUsController {

    @Autowired
    private AboutUsService aboutUsService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AboutUs record) {
        List<AboutUs> pp = aboutUsService.getAboutUsList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAboutUs", method = RequestMethod.GET)
    @ResponseBody
    public Result getAboutUs(@RequestParam(required = false, value = "id") String id) {
        AboutUs data = aboutUsService.getAboutUsById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AboutUs record) {
        AboutUs data = aboutUsService.getAboutUs(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AboutUs record) {
        Map<String, Object> result = new HashMap<>();

        List<AboutUs> pp =aboutUsService.getAboutUsByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AboutUs record) {
        boolean num = aboutUsService.createAboutUs(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAboutUs(AboutUs record) {
        boolean num = aboutUsService.updateAboutUs(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAboutUs(@RequestParam(required = true, value = "id") String id) {

        boolean num = aboutUsService.deleteAboutUs(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AboutUs record) throws Exception {

    List<AboutUs> aboutUss = aboutUsService.getAboutUsList(record);


        String sheetName = "about_us";
        String titleName = "关于我们数据表";
        String fileName = "关于我们表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "标题" ,   "介绍" ,   "图片"  };
        String[][] dataList = new String[aboutUss.size()][9];

        for (int i = 0; i < aboutUss.size(); i++) {

                        dataList[i][0] = String.valueOf(aboutUss.get(i).getId());
                        dataList[i][1] = String.valueOf(aboutUss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aboutUss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aboutUss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aboutUss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aboutUss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aboutUss.get(i).getTitle());
                        dataList[i][7] = String.valueOf(aboutUss.get(i).getDescription());
                        dataList[i][8] = String.valueOf(aboutUss.get(i).getImage());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

